require 'pandur/version'
require 'pandur/config'
require 'pandur/host'
require 'net/ssh/errors'
require 'logger'
require 'yaml'

class Pandur
  include Pandur::Config

  def initialize(conf = {})
    logger.level = conf[:log_level] || Logger::ERROR
    load_config(conf[:config_file] || '~/.pandur.yaml')
  end

  def run(conf = {})
    logger.debug("running ..")
    config('hosts').each do |host|
      check(host)
    end
    logger.debug(".. finished")
  end

  private

  def check(target)
    Pandur::Host.new(target).check
  rescue Net::SSH::AuthenticationFailed
    puts "Failed to connect: #{$!.message}"
  end

end
