class Pandur
  class Check
    include Pandur::Config

    def initialize(target)
      @config = target
    end

    def check(ssh)
      logger.debug("Checking #{@config['name']}")
      if @config['pid_file']
        print "Checking #{@config['name']}: "
        escaped_pid_file = @config['pid_file'].gsub('\'', '\\\'')
        if(ssh_exec!(ssh, "test -r '#{escaped_pid_file}' && test -n '`ps -ef | grep -v grep | grep \`cat '#{escaped_pid_file}'\``'")[2] > 0)
          puts "FAIL"
        else
          puts "OK"
        end
      else
        logger.debug("cannot check #{@config.inspect}")
      end
    end

    private

    def ssh_exec!(ssh, command)
      stdout_data = ""
      stderr_data = ""
      exit_code = nil
      exit_signal = nil
      ssh.open_channel do |channel|
        channel.exec(command) do |ch, success|
          unless success
            abort "FAILED: couldn't execute command (ssh.channel.exec)"
          end
          channel.on_data do |ch,data|
            stdout_data+=data
          end

          channel.on_extended_data do |ch,type,data|
            stderr_data+=data
          end

          channel.on_request("exit-status") do |ch,data|
            exit_code = data.read_long
          end

          channel.on_request("exit-signal") do |ch, data|
            exit_signal = data.read_long
          end
        end
      end
      ssh.loop
      [stdout_data, stderr_data, exit_code, exit_signal]
    end
  end
end
