# To access configuration (and logging), just include this module to your class,
# and you can directly access all configuration and the logging.
#
#   class ExampleClass
#     include Pandur::Config
#
#     def some_method
#       logger.debug(config('some_config'))
#     end
#   end

class Pandur
  module Config
    @@config = {}

    def load_config(file)
      logger.debug("Loading configuration from #{file.to_s}")
      @@config = YAML::load_file(File.expand_path(file))
    end

    def logger
      @@logger ||= Logger.new(STDERR)
    end

    def config(*params)
      @@config ||= {}
      case params.length()
      when 0
        @@config
      when 1
        @@config[params.first]
      else
        @@config[params[0]] = params[1]
      end
    end
  end
end
