require 'net/ssh'
require 'pandur/check'

class Pandur
  class Host
    include Pandur::Config

    def initialize(target)
      @config = target
    end

    def check
      logger.debug("Connecting to #{@config['username']}@#{@config['hostname']}")
      Net::SSH.start(@config['hostname'], @config['username'],
                     :password => @config['password']) do |ssh|
        @config['check'].each do |check|
          Pandur::Check.new(check).check(ssh)
        end
      end
    end

  end
end
